var parser = (function() {
    /*
     * Generated by PEG.js 0.8.0.
     *
     * http://pegjs.majda.cz/
     */

    function peg$subclass(child, parent) {
        function ctor() { this.constructor = child; }
        ctor.prototype = parent.prototype;
        child.prototype = new ctor();
    }

    function SyntaxError(message, expected, found, offset, line, column) {
        this.message  = message;
        this.expected = expected;
        this.found    = found;
        this.offset   = offset;
        this.line     = line;
        this.column   = column;

        this.name     = "SyntaxError";
    }

    peg$subclass(SyntaxError, Error);

    function parse(input) {
        var options = arguments.length > 1 ? arguments[1] : {},

            peg$FAILED = {},

            peg$startRuleFunctions = { start: peg$parsestart },
            peg$startRuleFunction  = peg$parsestart,

            peg$c0 = [],
            peg$c1 = { type: "other", description: "buffer" },
            peg$c2 = peg$FAILED,
            peg$c3 = function(e, w) { return {"buffer": e + w.join('')} },
            peg$c4 = void 0,
            peg$c5 = { type: "any", description: "any character" },
            peg$c6 = function(c) { return c },
            peg$c7 = function(b) { return {"buffer": b.join('')} },
            peg$c8 = ":",
            peg$c9 = { type: "literal", value: ":", description: "\":\"" },
            peg$c10 = function(b) {return b},
            peg$c11 = function(c, e) { return {color: c, text: e.join('')}},
            peg$c12 = /^[a-z]/,
            peg$c13 = { type: "class", value: "[a-z]", description: "[a-z]" },
            peg$c14 = function(c) { return c.join('') },
            peg$c15 = null,
            peg$c16 = function(e) {return {reset: true, text: e ? e.join('') : '' }},
            peg$c17 = function(after) {return after},
            peg$c18 = "%C",
            peg$c19 = { type: "literal", value: "%C", description: "\"%C\"" },
            peg$c20 = "%R",
            peg$c21 = { type: "literal", value: "%R", description: "\"%R\"" },
            peg$c22 = "\n",
            peg$c23 = { type: "literal", value: "\n", description: "\"\\n\"" },
            peg$c24 = "\r\n",
            peg$c25 = { type: "literal", value: "\r\n", description: "\"\\r\\n\"" },
            peg$c26 = "\r",
            peg$c27 = { type: "literal", value: "\r", description: "\"\\r\"" },
            peg$c28 = "\u2028",
            peg$c29 = { type: "literal", value: "\u2028", description: "\"\\u2028\"" },
            peg$c30 = "\u2029",
            peg$c31 = { type: "literal", value: "\u2029", description: "\"\\u2029\"" },
            peg$c32 = /^[\t\x0B\f \xA0\uFEFF]/,
            peg$c33 = { type: "class", value: "[\\t\\x0B\\f \\xA0\\uFEFF]", description: "[\\t\\x0B\\f \\xA0\\uFEFF]" },

            peg$currPos          = 0,
            peg$reportedPos      = 0,
            peg$cachedPos        = 0,
            peg$cachedPosDetails = { line: 1, column: 1, seenCR: false },
            peg$maxFailPos       = 0,
            peg$maxFailExpected  = [],
            peg$silentFails      = 0,

            peg$result;

        if ("startRule" in options) {
            if (!(options.startRule in peg$startRuleFunctions)) {
                throw new Error("Can't start parsing from rule \"" + options.startRule + "\".");
            }

            peg$startRuleFunction = peg$startRuleFunctions[options.startRule];
        }

        function text() {
            return input.substring(peg$reportedPos, peg$currPos);
        }

        function offset() {
            return peg$reportedPos;
        }

        function line() {
            return peg$computePosDetails(peg$reportedPos).line;
        }

        function column() {
            return peg$computePosDetails(peg$reportedPos).column;
        }

        function expected(description) {
            throw peg$buildException(
                    null,
                    [{ type: "other", description: description }],
                    peg$reportedPos
            );
        }

        function error(message) {
            throw peg$buildException(message, null, peg$reportedPos);
        }

        function peg$computePosDetails(pos) {
            function advance(details, startPos, endPos) {
                var p, ch;

                for (p = startPos; p < endPos; p++) {
                    ch = input.charAt(p);
                    if (ch === "\n") {
                        if (!details.seenCR) { details.line++; }
                        details.column = 1;
                        details.seenCR = false;
                    } else if (ch === "\r" || ch === "\u2028" || ch === "\u2029") {
                        details.line++;
                        details.column = 1;
                        details.seenCR = true;
                    } else {
                        details.column++;
                        details.seenCR = false;
                    }
                }
            }

            if (peg$cachedPos !== pos) {
                if (peg$cachedPos > pos) {
                    peg$cachedPos = 0;
                    peg$cachedPosDetails = { line: 1, column: 1, seenCR: false };
                }
                advance(peg$cachedPosDetails, peg$cachedPos, pos);
                peg$cachedPos = pos;
            }

            return peg$cachedPosDetails;
        }

        function peg$fail(expected) {
            if (peg$currPos < peg$maxFailPos) { return; }

            if (peg$currPos > peg$maxFailPos) {
                peg$maxFailPos = peg$currPos;
                peg$maxFailExpected = [];
            }

            peg$maxFailExpected.push(expected);
        }

        function peg$buildException(message, expected, pos) {
            function cleanupExpected(expected) {
                var i = 1;

                expected.sort(function(a, b) {
                    if (a.description < b.description) {
                        return -1;
                    } else if (a.description > b.description) {
                        return 1;
                    } else {
                        return 0;
                    }
                });

                while (i < expected.length) {
                    if (expected[i - 1] === expected[i]) {
                        expected.splice(i, 1);
                    } else {
                        i++;
                    }
                }
            }

            function buildMessage(expected, found) {
                function stringEscape(s) {
                    function hex(ch) { return ch.charCodeAt(0).toString(16).toUpperCase(); }

                    return s
                            .replace(/\\/g,   '\\\\')
                            .replace(/"/g,    '\\"')
                            .replace(/\x08/g, '\\b')
                            .replace(/\t/g,   '\\t')
                            .replace(/\n/g,   '\\n')
                            .replace(/\f/g,   '\\f')
                            .replace(/\r/g,   '\\r')
                            .replace(/[\x00-\x07\x0B\x0E\x0F]/g, function(ch) { return '\\x0' + hex(ch); })
                            .replace(/[\x10-\x1F\x80-\xFF]/g,    function(ch) { return '\\x'  + hex(ch); })
                            .replace(/[\u0180-\u0FFF]/g,         function(ch) { return '\\u0' + hex(ch); })
                            .replace(/[\u1080-\uFFFF]/g,         function(ch) { return '\\u'  + hex(ch); });
                }

                var expectedDescs = new Array(expected.length),
                    expectedDesc, foundDesc, i;

                for (i = 0; i < expected.length; i++) {
                    expectedDescs[i] = expected[i].description;
                }

                expectedDesc = expected.length > 1
                        ? expectedDescs.slice(0, -1).join(", ")
                        + " or "
                        + expectedDescs[expected.length - 1]
                        : expectedDescs[0];

                foundDesc = found ? "\"" + stringEscape(found) + "\"" : "end of input";

                return "Expected " + expectedDesc + " but " + foundDesc + " found.";
            }

            var posDetails = peg$computePosDetails(pos),
                found      = pos < input.length ? input.charAt(pos) : null;

            if (expected !== null) {
                cleanupExpected(expected);
            }

            return new SyntaxError(
                            message !== null ? message : buildMessage(expected, found),
                    expected,
                    found,
                    pos,
                    posDetails.line,
                    posDetails.column
            );
        }

        function peg$parsestart() {
            var s0;

            s0 = peg$parsebody();

            return s0;
        }

        function peg$parsebody() {
            var s0, s1;

            s0 = [];
            s1 = peg$parseitem();
            while (s1 !== peg$FAILED) {
                s0.push(s1);
                s1 = peg$parseitem();
            }

            return s0;
        }

        function peg$parseitem() {
            var s0;

            s0 = peg$parsetag();
            if (s0 === peg$FAILED) {
                s0 = peg$parsebuffer();
                if (s0 === peg$FAILED) {
                    s0 = peg$parsereset();
                }
            }

            return s0;
        }

        function peg$parsebuffer() {
            var s0, s1, s2, s3, s4, s5;

            peg$silentFails++;
            s0 = peg$currPos;
            s1 = peg$parseeol();
            if (s1 !== peg$FAILED) {
                s2 = [];
                s3 = peg$parsews();
                while (s3 !== peg$FAILED) {
                    s2.push(s3);
                    s3 = peg$parsews();
                }
                if (s2 !== peg$FAILED) {
                    peg$reportedPos = s0;
                    s1 = peg$c3(s1, s2);
                    s0 = s1;
                } else {
                    peg$currPos = s0;
                    s0 = peg$c2;
                }
            } else {
                peg$currPos = s0;
                s0 = peg$c2;
            }
            if (s0 === peg$FAILED) {
                s0 = peg$currPos;
                s1 = [];
                s2 = peg$currPos;
                s3 = peg$currPos;
                peg$silentFails++;
                s4 = peg$parsetag();
                peg$silentFails--;
                if (s4 === peg$FAILED) {
                    s3 = peg$c4;
                } else {
                    peg$currPos = s3;
                    s3 = peg$c2;
                }
                if (s3 !== peg$FAILED) {
                    s4 = peg$currPos;
                    peg$silentFails++;
                    s5 = peg$parsereset();
                    peg$silentFails--;
                    if (s5 === peg$FAILED) {
                        s4 = peg$c4;
                    } else {
                        peg$currPos = s4;
                        s4 = peg$c2;
                    }
                    if (s4 !== peg$FAILED) {
                        if (input.length > peg$currPos) {
                            s5 = input.charAt(peg$currPos);
                            peg$currPos++;
                        } else {
                            s5 = peg$FAILED;
                            if (peg$silentFails === 0) { peg$fail(peg$c5); }
                        }
                        if (s5 !== peg$FAILED) {
                            peg$reportedPos = s2;
                            s3 = peg$c6(s5);
                            s2 = s3;
                        } else {
                            peg$currPos = s2;
                            s2 = peg$c2;
                        }
                    } else {
                        peg$currPos = s2;
                        s2 = peg$c2;
                    }
                } else {
                    peg$currPos = s2;
                    s2 = peg$c2;
                }
                if (s2 !== peg$FAILED) {
                    while (s2 !== peg$FAILED) {
                        s1.push(s2);
                        s2 = peg$currPos;
                        s3 = peg$currPos;
                        peg$silentFails++;
                        s4 = peg$parsetag();
                        peg$silentFails--;
                        if (s4 === peg$FAILED) {
                            s3 = peg$c4;
                        } else {
                            peg$currPos = s3;
                            s3 = peg$c2;
                        }
                        if (s3 !== peg$FAILED) {
                            s4 = peg$currPos;
                            peg$silentFails++;
                            s5 = peg$parsereset();
                            peg$silentFails--;
                            if (s5 === peg$FAILED) {
                                s4 = peg$c4;
                            } else {
                                peg$currPos = s4;
                                s4 = peg$c2;
                            }
                            if (s4 !== peg$FAILED) {
                                if (input.length > peg$currPos) {
                                    s5 = input.charAt(peg$currPos);
                                    peg$currPos++;
                                } else {
                                    s5 = peg$FAILED;
                                    if (peg$silentFails === 0) { peg$fail(peg$c5); }
                                }
                                if (s5 !== peg$FAILED) {
                                    peg$reportedPos = s2;
                                    s3 = peg$c6(s5);
                                    s2 = s3;
                                } else {
                                    peg$currPos = s2;
                                    s2 = peg$c2;
                                }
                            } else {
                                peg$currPos = s2;
                                s2 = peg$c2;
                            }
                        } else {
                            peg$currPos = s2;
                            s2 = peg$c2;
                        }
                    }
                } else {
                    s1 = peg$c2;
                }
                if (s1 !== peg$FAILED) {
                    peg$reportedPos = s0;
                    s1 = peg$c7(s1);
                }
                s0 = s1;
            }
            peg$silentFails--;
            if (s0 === peg$FAILED) {
                s1 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c1); }
            }

            return s0;
        }

        function peg$parsetag() {
            var s0, s1, s2, s3, s4, s5, s6, s7, s8;

            s0 = peg$currPos;
            s1 = peg$parseld();
            if (s1 !== peg$FAILED) {
                s2 = peg$parsecolor();
                if (s2 !== peg$FAILED) {
                    if (input.charCodeAt(peg$currPos) === 58) {
                        s3 = peg$c8;
                        peg$currPos++;
                    } else {
                        s3 = peg$FAILED;
                        if (peg$silentFails === 0) { peg$fail(peg$c9); }
                    }
                    if (s3 !== peg$FAILED) {
                        s4 = [];
                        s5 = peg$currPos;
                        s6 = peg$currPos;
                        peg$silentFails++;
                        s7 = peg$parseld();
                        peg$silentFails--;
                        if (s7 === peg$FAILED) {
                            s6 = peg$c4;
                        } else {
                            peg$currPos = s6;
                            s6 = peg$c2;
                        }
                        if (s6 !== peg$FAILED) {
                            s7 = peg$currPos;
                            peg$silentFails++;
                            s8 = peg$parserd();
                            peg$silentFails--;
                            if (s8 === peg$FAILED) {
                                s7 = peg$c4;
                            } else {
                                peg$currPos = s7;
                                s7 = peg$c2;
                            }
                            if (s7 !== peg$FAILED) {
                                if (input.length > peg$currPos) {
                                    s8 = input.charAt(peg$currPos);
                                    peg$currPos++;
                                } else {
                                    s8 = peg$FAILED;
                                    if (peg$silentFails === 0) { peg$fail(peg$c5); }
                                }
                                if (s8 !== peg$FAILED) {
                                    peg$reportedPos = s5;
                                    s6 = peg$c10(s8);
                                    s5 = s6;
                                } else {
                                    peg$currPos = s5;
                                    s5 = peg$c2;
                                }
                            } else {
                                peg$currPos = s5;
                                s5 = peg$c2;
                            }
                        } else {
                            peg$currPos = s5;
                            s5 = peg$c2;
                        }
                        if (s5 !== peg$FAILED) {
                            while (s5 !== peg$FAILED) {
                                s4.push(s5);
                                s5 = peg$currPos;
                                s6 = peg$currPos;
                                peg$silentFails++;
                                s7 = peg$parseld();
                                peg$silentFails--;
                                if (s7 === peg$FAILED) {
                                    s6 = peg$c4;
                                } else {
                                    peg$currPos = s6;
                                    s6 = peg$c2;
                                }
                                if (s6 !== peg$FAILED) {
                                    s7 = peg$currPos;
                                    peg$silentFails++;
                                    s8 = peg$parserd();
                                    peg$silentFails--;
                                    if (s8 === peg$FAILED) {
                                        s7 = peg$c4;
                                    } else {
                                        peg$currPos = s7;
                                        s7 = peg$c2;
                                    }
                                    if (s7 !== peg$FAILED) {
                                        if (input.length > peg$currPos) {
                                            s8 = input.charAt(peg$currPos);
                                            peg$currPos++;
                                        } else {
                                            s8 = peg$FAILED;
                                            if (peg$silentFails === 0) { peg$fail(peg$c5); }
                                        }
                                        if (s8 !== peg$FAILED) {
                                            peg$reportedPos = s5;
                                            s6 = peg$c10(s8);
                                            s5 = s6;
                                        } else {
                                            peg$currPos = s5;
                                            s5 = peg$c2;
                                        }
                                    } else {
                                        peg$currPos = s5;
                                        s5 = peg$c2;
                                    }
                                } else {
                                    peg$currPos = s5;
                                    s5 = peg$c2;
                                }
                            }
                        } else {
                            s4 = peg$c2;
                        }
                        if (s4 !== peg$FAILED) {
                            peg$reportedPos = s0;
                            s1 = peg$c11(s2, s4);
                            s0 = s1;
                        } else {
                            peg$currPos = s0;
                            s0 = peg$c2;
                        }
                    } else {
                        peg$currPos = s0;
                        s0 = peg$c2;
                    }
                } else {
                    peg$currPos = s0;
                    s0 = peg$c2;
                }
            } else {
                peg$currPos = s0;
                s0 = peg$c2;
            }

            return s0;
        }

        function peg$parsecolor() {
            var s0, s1, s2;

            s0 = peg$currPos;
            s1 = [];
            if (peg$c12.test(input.charAt(peg$currPos))) {
                s2 = input.charAt(peg$currPos);
                peg$currPos++;
            } else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c13); }
            }
            if (s2 !== peg$FAILED) {
                while (s2 !== peg$FAILED) {
                    s1.push(s2);
                    if (peg$c12.test(input.charAt(peg$currPos))) {
                        s2 = input.charAt(peg$currPos);
                        peg$currPos++;
                    } else {
                        s2 = peg$FAILED;
                        if (peg$silentFails === 0) { peg$fail(peg$c13); }
                    }
                }
            } else {
                s1 = peg$c2;
            }
            if (s1 !== peg$FAILED) {
                peg$reportedPos = s0;
                s1 = peg$c14(s1);
            }
            s0 = s1;

            return s0;
        }

        function peg$parsereset() {
            var s0, s1, s2;

            s0 = peg$currPos;
            s1 = peg$parserd();
            if (s1 !== peg$FAILED) {
                s2 = peg$parseafter();
                if (s2 === peg$FAILED) {
                    s2 = peg$c15;
                }
                if (s2 !== peg$FAILED) {
                    peg$reportedPos = s0;
                    s1 = peg$c16(s2);
                    s0 = s1;
                } else {
                    peg$currPos = s0;
                    s0 = peg$c2;
                }
            } else {
                peg$currPos = s0;
                s0 = peg$c2;
            }

            return s0;
        }

        function peg$parseafter() {
            var s0, s1, s2, s3, s4;

            s0 = [];
            s1 = peg$currPos;
            s2 = peg$currPos;
            peg$silentFails++;
            s3 = peg$parseld();
            peg$silentFails--;
            if (s3 === peg$FAILED) {
                s2 = peg$c4;
            } else {
                peg$currPos = s2;
                s2 = peg$c2;
            }
            if (s2 !== peg$FAILED) {
                s3 = peg$currPos;
                peg$silentFails++;
                s4 = peg$parserd();
                peg$silentFails--;
                if (s4 === peg$FAILED) {
                    s3 = peg$c4;
                } else {
                    peg$currPos = s3;
                    s3 = peg$c2;
                }
                if (s3 !== peg$FAILED) {
                    if (input.length > peg$currPos) {
                        s4 = input.charAt(peg$currPos);
                        peg$currPos++;
                    } else {
                        s4 = peg$FAILED;
                        if (peg$silentFails === 0) { peg$fail(peg$c5); }
                    }
                    if (s4 !== peg$FAILED) {
                        peg$reportedPos = s1;
                        s2 = peg$c17(s4);
                        s1 = s2;
                    } else {
                        peg$currPos = s1;
                        s1 = peg$c2;
                    }
                } else {
                    peg$currPos = s1;
                    s1 = peg$c2;
                }
            } else {
                peg$currPos = s1;
                s1 = peg$c2;
            }
            if (s1 !== peg$FAILED) {
                while (s1 !== peg$FAILED) {
                    s0.push(s1);
                    s1 = peg$currPos;
                    s2 = peg$currPos;
                    peg$silentFails++;
                    s3 = peg$parseld();
                    peg$silentFails--;
                    if (s3 === peg$FAILED) {
                        s2 = peg$c4;
                    } else {
                        peg$currPos = s2;
                        s2 = peg$c2;
                    }
                    if (s2 !== peg$FAILED) {
                        s3 = peg$currPos;
                        peg$silentFails++;
                        s4 = peg$parserd();
                        peg$silentFails--;
                        if (s4 === peg$FAILED) {
                            s3 = peg$c4;
                        } else {
                            peg$currPos = s3;
                            s3 = peg$c2;
                        }
                        if (s3 !== peg$FAILED) {
                            if (input.length > peg$currPos) {
                                s4 = input.charAt(peg$currPos);
                                peg$currPos++;
                            } else {
                                s4 = peg$FAILED;
                                if (peg$silentFails === 0) { peg$fail(peg$c5); }
                            }
                            if (s4 !== peg$FAILED) {
                                peg$reportedPos = s1;
                                s2 = peg$c17(s4);
                                s1 = s2;
                            } else {
                                peg$currPos = s1;
                                s1 = peg$c2;
                            }
                        } else {
                            peg$currPos = s1;
                            s1 = peg$c2;
                        }
                    } else {
                        peg$currPos = s1;
                        s1 = peg$c2;
                    }
                }
            } else {
                s0 = peg$c2;
            }

            return s0;
        }

        function peg$parseld() {
            var s0;

            if (input.substr(peg$currPos, 2) === peg$c18) {
                s0 = peg$c18;
                peg$currPos += 2;
            } else {
                s0 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c19); }
            }

            return s0;
        }

        function peg$parserd() {
            var s0;

            if (input.substr(peg$currPos, 2) === peg$c20) {
                s0 = peg$c20;
                peg$currPos += 2;
            } else {
                s0 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c21); }
            }

            return s0;
        }

        function peg$parseeol() {
            var s0;

            if (input.charCodeAt(peg$currPos) === 10) {
                s0 = peg$c22;
                peg$currPos++;
            } else {
                s0 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c23); }
            }
            if (s0 === peg$FAILED) {
                if (input.substr(peg$currPos, 2) === peg$c24) {
                    s0 = peg$c24;
                    peg$currPos += 2;
                } else {
                    s0 = peg$FAILED;
                    if (peg$silentFails === 0) { peg$fail(peg$c25); }
                }
                if (s0 === peg$FAILED) {
                    if (input.charCodeAt(peg$currPos) === 13) {
                        s0 = peg$c26;
                        peg$currPos++;
                    } else {
                        s0 = peg$FAILED;
                        if (peg$silentFails === 0) { peg$fail(peg$c27); }
                    }
                    if (s0 === peg$FAILED) {
                        if (input.charCodeAt(peg$currPos) === 8232) {
                            s0 = peg$c28;
                            peg$currPos++;
                        } else {
                            s0 = peg$FAILED;
                            if (peg$silentFails === 0) { peg$fail(peg$c29); }
                        }
                        if (s0 === peg$FAILED) {
                            if (input.charCodeAt(peg$currPos) === 8233) {
                                s0 = peg$c30;
                                peg$currPos++;
                            } else {
                                s0 = peg$FAILED;
                                if (peg$silentFails === 0) { peg$fail(peg$c31); }
                            }
                        }
                    }
                }
            }

            return s0;
        }

        function peg$parsews() {
            var s0;

            if (peg$c32.test(input.charAt(peg$currPos))) {
                s0 = input.charAt(peg$currPos);
                peg$currPos++;
            } else {
                s0 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$c33); }
            }
            if (s0 === peg$FAILED) {
                s0 = peg$parseeol();
            }

            return s0;
        }

        peg$result = peg$startRuleFunction();

        if (peg$result !== peg$FAILED && peg$currPos === input.length) {
            return peg$result;
        } else {
            if (peg$result !== peg$FAILED && peg$currPos < input.length) {
                peg$fail({ type: "end", description: "end of input" });
            }

            throw peg$buildException(null, peg$maxFailExpected, peg$maxFailPos);
        }
    }

    return {
        SyntaxError: SyntaxError,
        parse:       parse
    };
})();

